Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/FastHyperVolumeTests.cs	(revision 13673)
@@ -0,0 +1,137 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Problems.MultiObjectiveTestFunctions;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace MultiObjectiveTestfunctionTests {
+  [TestClass]
+  public class FastHypervolumeTest {
+    /// <summary>
+    ///  /*
+    /// +-----+
+    /// |     |
+    /// |  x  |
+    /// |     |
+    /// +-----+
+    /// 
+    /// box between(0,0,0) and(1,1,1) with singular point pareto front at(0.5,0.5,0.5)
+    /// Hypervolume should be 0.125;  
+    /// 
+    /// </summary>
+    [TestMethod]
+    public void SinglePointTest() {
+      double[] point = new double[] { 0.5, 0.5, 0.5 };
+      double[][] front = { point };
+      double[] referencePoint = new double[] { 1, 1, 1 };
+      double hv = FastHV2.Calculate(front, referencePoint);
+      Assert.AreEqual(0.125, hv);
+    }
+
+    /// <summary>
+    ///  /*
+    /// +-----+
+    /// | x   |
+    /// |     |
+    /// |     |
+    /// +-----+
+    /// 
+    /// box between(0,0) and(1,1) with singular point pareto front at a random Location
+    /// Sum of the Hypervolume to each of the corners should be 1;  
+    /// 
+    /// </summary>
+    [TestMethod]
+    public void RandomSinglePointTest() {
+      //Front with a single Point
+      double[] point = new double[3];
+      Random r = new Random();
+
+      point[0] = r.NextDouble();
+      point[1] = r.NextDouble();
+      point[2] = r.NextDouble();
+      double[][] front = { point };
+
+      double[] referencePoint = new double[3];
+
+      //Northeast
+      referencePoint[0] = 1;
+      referencePoint[1] = 1;
+      referencePoint[2] = 1;
+      double hv = FastHV2.Calculate(front, referencePoint);
+      double hv2 = 1;
+      foreach (double d in point) {
+        hv2 *= Math.Abs(d - 1);
+      }
+      Assert.AreEqual(hv2, hv);
+    }
+
+    /// <summary>
+    ///  /*
+    /// x-----+
+    /// |     |
+    /// |  X  |
+    /// |     |
+    /// +-----x
+    /// 
+    /// box between(0,0,0) and(1,1,1) with three point (pareto) front at (1,0,0), (0.5,0.5,0)  and (0,1,0) 
+    /// Hypervolume should be 0.25
+    /// </summary>
+    //[TestMethod]
+    public void DiagonalPointTest() {
+      //Front with three points
+      double[] point1 = new double[] { 1, 0, 0 };
+      double[] point2 = new double[] { 0, 1, 0 };
+      double[] point3 = new double[] { 0.5, 0.5, 0 };
+      double[][] front = { point1, point2, point3 };
+
+      double[] referencePoint = new double[] { 1, 1, 1 };
+      double hv = FastHV2.Calculate(front, referencePoint);
+      Assert.AreEqual(0.25, hv);
+    }
+
+
+    public void HypervolumeConsistencyTest() {
+      double[] referencePoint = new double[] { 1, 1, 1 };
+      bool[] maximization = new bool[3];
+      List<double[]> points = new List<double[]>();
+      Random r = new Random();
+      for (int i = 0; i < 100; i++) {
+        double[] p = new double[3];
+        p[0] = r.NextDouble();
+        p[1] = r.NextDouble();
+        points.Add(p);
+      }
+      var front = NonDominatedSelect.selectNonDominatedVectors(points, maximization, true);
+
+      double dim3hv = FastHV2.Calculate(front, referencePoint);
+      double dim2hv = Hypervolume.Calculate(front, referencePoint, maximization);
+
+
+
+
+    }
+
+
+  }
+
+
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/GenerationalDistanceTest.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/GenerationalDistanceTest.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/GenerationalDistanceTest.cs	(revision 13673)
@@ -0,0 +1,128 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using HeuristicLab.Problems.MultiObjectiveTestFunctions;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace MultiObjectiveTestfunctionTests {
+  [TestClass]
+  public class GenerationalDistanceTest {
+
+
+
+
+
+    [TestMethod]
+    [ExpectedException(typeof(ArgumentException))]
+    public void EmptyOptimalFrontTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+      double[][] referencefront = { };
+      GenerationalDistance.Calculate(front, referencefront, 1);
+    }
+
+    [TestMethod]
+    [ExpectedException(typeof(ArgumentException))]
+    public void EmptyFrontTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { };
+      double[][] referencefront = { point };
+      GenerationalDistance.Calculate(front, referencefront, 1);
+    }
+
+    [TestMethod]
+    public void SamePointTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+      double[] point1 = new double[2];
+      point1[0] = 0.5;
+      point1[1] = 0.5;
+      double[][] referencefront = { point1 };
+      double dist = GenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(0, dist);
+    }
+
+    [TestMethod]
+    public void SinglePointTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[][] front = { point };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 1;
+      double[][] referencefront = { point2 };
+      double dist = GenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(Math.Sqrt(2), dist);
+    }
+
+    [TestMethod]
+    public void DifferentSizesTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 1;
+      point1[1] = 0.5;
+      double[][] front = { point, point1 };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[][] referencefront = { point2 };
+      double dist = GenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(0.75, dist);
+    }
+
+    [TestMethod]
+    public void QuadraticTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+      double[][] front = { point, point1 };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 1;
+      point3[1] = 1;
+      double[][] referencefront = { point2, point3 };
+      double dist = GenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(1, dist);
+    }
+
+
+
+  }
+
+
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/HyperVolumeTests.cs	(revision 13673)
@@ -0,0 +1,279 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using HeuristicLab.Problems.MultiObjectiveTestFunctions;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace MultiObjectiveTestfunctionTests {
+  [TestClass]
+  public class HypervolumeTest {
+
+
+
+
+    /// <summary>
+    ///  /*
+    /// +-----+
+    /// |     |
+    /// |  x  |
+    /// |     |
+    /// +-----+
+    /// 
+    /// box between(0,0) and(1,1) with singular point pareto front at(0.5,0.5)
+    /// Hypervolume to each of the corners should be 0.25;  
+    /// 
+    /// </summary>
+    [TestMethod]
+    public void SinglePointTest() {
+
+      //Front with a single Point
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //Northeast
+      maximization = new bool[] { false, false };
+      referencePoint[0] = 1;
+      referencePoint[1] = 1;
+      double ne = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, ne);
+
+      //NorthWest
+      maximization = new bool[] { true, false };
+      referencePoint[0] = 0;
+      referencePoint[1] = 1;
+      double nw = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, nw);
+
+      //SouthWest
+      maximization = new bool[] { true, true };
+      referencePoint[0] = 0;
+      referencePoint[1] = 0;
+      double sw = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, sw);
+
+      //SouthEast
+      maximization = new bool[] { false, true };
+      referencePoint[0] = 1;
+      referencePoint[1] = 0;
+      double se = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, se);
+
+
+    }
+
+    /// <summary>
+    ///  /*
+    /// +-----+
+    /// | x   |
+    /// |     |
+    /// |     |
+    /// +-----+
+    /// 
+    /// box between(0,0) and(1,1) with singular point pareto front at a random Location
+    /// Sum of the Hypervolume to each of the corners should be 1;  
+    /// 
+    /// </summary>
+    [TestMethod]
+    public void RandomSinglePointTest() {
+      //Front with a single Point
+      double[] point = new double[2];
+      Random r = new Random();
+
+      point[0] = r.NextDouble();
+      point[1] = r.NextDouble();
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //Northeast
+      maximization = new bool[] { false, false };
+      referencePoint[0] = 1;
+      referencePoint[1] = 1;
+      double ne = Hypervolume.Calculate(front, referencePoint, maximization);
+
+      //NorthWest
+      maximization = new bool[] { true, false };
+      referencePoint[0] = 0;
+      referencePoint[1] = 1;
+      double nw = Hypervolume.Calculate(front, referencePoint, maximization);
+
+      //SouthWest
+      maximization = new bool[] { true, true };
+      referencePoint[0] = 0;
+      referencePoint[1] = 0;
+      double sw = Hypervolume.Calculate(front, referencePoint, maximization);
+
+      //SouthEast
+      maximization = new bool[] { false, true };
+      referencePoint[0] = 1;
+      referencePoint[1] = 0;
+      double se = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(1.0, ne + se + nw + sw);
+    }
+
+    /// <summary>
+    ///  /*
+    /// x-----+
+    /// |     |
+    /// |  X  |
+    /// |     |
+    /// +-----x
+    /// 
+    /// box between(0,0) and(1,1) with three point (pareto) front at (1,0), (0.5,0.5)  and (0,1) 
+    /// Hypervolume to (1,0) and (0,1) of the corners should be 1 (dominated Points need to be reemoved beforehand and   
+    /// Hypervolume to (0,0) and (1,1) of the corners should be 0.25
+    /// </summary>
+    [TestMethod]
+    public void DiagonalPointTest() {
+      //Front with three points
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 0.5;
+      point3[1] = 0.5;
+      double[][] front = { point1, point2, point3 };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //Northeast
+      maximization = new bool[] { false, false };
+      referencePoint[0] = 1;
+      referencePoint[1] = 1;
+      double ne = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, ne);
+
+      //NorthWest
+      maximization = new bool[] { true, false };
+      referencePoint[0] = 0;
+      referencePoint[1] = 1;
+      double nw = Hypervolume.Calculate(NonDominatedSelect.selectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
+      Assert.AreEqual(1, nw);
+
+      //SouthWest
+      maximization = new bool[] { true, true };
+      referencePoint[0] = 0;
+      referencePoint[1] = 0;
+      double sw = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, sw);
+
+      //SouthEast
+      maximization = new bool[] { false, true };
+      referencePoint[0] = 1;
+      referencePoint[1] = 0;
+      double se = Hypervolume.Calculate(NonDominatedSelect.selectNonDominatedVectors(front, maximization, true), referencePoint, maximization);
+      Assert.AreEqual(1, se);
+
+    }
+
+    [TestMethod()]
+    [ExpectedException(typeof(ArgumentException))]
+    public void ReferencePointViolationNE() {
+      //Front with a single Point
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //Northeast
+      maximization = new bool[] { true, true };
+      referencePoint[0] = 1;
+      referencePoint[1] = 1;
+      double ne = Hypervolume.Calculate(front, referencePoint, maximization);
+    }
+
+    [TestMethod()]
+    [ExpectedException(typeof(ArgumentException))]
+    public void ReferencePointViolationNW() {
+      //Front with a single Point
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //NorthWest
+      maximization = new bool[] { false, true };
+      referencePoint[0] = 0;
+      referencePoint[1] = 1;
+      double nw = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, nw);
+    }
+
+    [TestMethod()]
+    [ExpectedException(typeof(ArgumentException))]
+    public void ReferencePointViolationSW() {
+      //Front with a single Point
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //SouthWest
+      maximization = new bool[] { false, false };
+      referencePoint[0] = 0;
+      referencePoint[1] = 0;
+      double sw = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, sw);
+    }
+
+    [TestMethod()]
+    [ExpectedException(typeof(ArgumentException))]
+    public void ReferencePointViolationSE() {
+      //Front with a single Point
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+
+      double[] referencePoint = new double[2];
+      bool[] maximization;
+
+      //SouthEast
+      maximization = new bool[] { true, false };
+      referencePoint[0] = 1;
+      referencePoint[1] = 0;
+      double se = Hypervolume.Calculate(front, referencePoint, maximization);
+      Assert.AreEqual(0.25, se);
+    }
+
+  }
+
+
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/InvertedGenerationalDistanceTest.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/InvertedGenerationalDistanceTest.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/InvertedGenerationalDistanceTest.cs	(revision 13673)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using HeuristicLab.Problems.MultiObjectiveTestFunctions;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace MultiObjectiveTestfunctionTests {
+  [TestClass]
+  public class InvertedGenerationalDistanceTest {
+
+    [TestMethod]
+    [ExpectedException(typeof(ArgumentException))]
+    public void EmptyOptimalFrontTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+      double[][] referencefront = { };
+      InvertedGenerationalDistance.Calculate(front, referencefront, 1);
+    }
+
+    [TestMethod]
+    [ExpectedException(typeof(ArgumentException))]
+    public void EmptyFrontTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { };
+      double[][] referencefront = { point };
+      InvertedGenerationalDistance.Calculate(front, referencefront, 1);
+    }
+
+    [TestMethod]
+    public void SamePointTest() {
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+      double[][] front = { point };
+      double[] point1 = new double[2];
+      point1[0] = 0.5;
+      point1[1] = 0.5;
+      double[][] referencefront = { point1 };
+      double dist = GenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(0, dist);
+    }
+
+    [TestMethod]
+    public void SinglePointTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[][] front = { point };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 1;
+      double[][] referencefront = { point2 };
+      double dist = InvertedGenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(Math.Sqrt(2), dist);
+    }
+
+    [TestMethod]
+    public void DifferentSizesTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 1;
+      point1[1] = 0.5;
+      double[][] front = { point, point1 };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[][] referencefront = { point2 };
+      double dist = InvertedGenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(0.5, dist);
+    }
+
+    [TestMethod]
+    public void QuadraticTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+      double[][] front = { point, point1 };
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 1;
+      point3[1] = 1;
+      double[][] referencefront = { point2, point3 };
+      double dist = InvertedGenerationalDistance.Calculate(front, referencefront, 1);
+      Assert.AreEqual(1, dist);
+    }
+
+
+
+  }
+
+
+}
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/MultiObjectiveTestfunctionTests.csproj	(revision 13673)
@@ -0,0 +1,105 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{2E42C743-37B3-494F-B30D-EDB0069D73C1}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>MultiObjectiveTestfunctionTests</RootNamespace>
+    <AssemblyName>MultiObjectiveTestfunctionTests</AssemblyName>
+    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+    <VisualStudioVersion Condition="'$(VisualStudioVersion)' == ''">10.0</VisualStudioVersion>
+    <VSToolsPath Condition="'$(VSToolsPath)' == ''">$(MSBuildExtensionsPath32)\Microsoft\VisualStudio\v$(VisualStudioVersion)</VSToolsPath>
+    <ReferencePath>$(ProgramFiles)\Common Files\microsoft shared\VSTT\$(VisualStudioVersion)\UITestExtensionPackages</ReferencePath>
+    <IsCodedUITest>False</IsCodedUITest>
+    <TestProjectType>UnitTest</TestProjectType>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.RealVectorEncoding-3.3">
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Encodings.RealVectorEncoding-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+  </ItemGroup>
+  <Choose>
+    <When Condition="('$(VisualStudioVersion)' == '10.0' or '$(VisualStudioVersion)' == '') and '$(TargetFrameworkVersion)' == 'v3.5'">
+      <ItemGroup>
+        <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework, Version=10.1.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL" />
+      </ItemGroup>
+    </When>
+    <Otherwise>
+      <ItemGroup>
+        <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework" />
+      </ItemGroup>
+    </Otherwise>
+  </Choose>
+  <ItemGroup>
+    <Compile Include="FastHyperVolumeTests.cs" />
+    <Compile Include="SpacingTest.cs" />
+    <Compile Include="InvertedGenerationalDistanceTest.cs" />
+    <Compile Include="GenerationalDistanceTest.cs" />
+    <Compile Include="HyperVolumeTests.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Problems.MultiObjectiveTestFunctions\3.3\HeuristicLab.Problems.MultiObjectiveTestFunctions-3.3.csproj">
+      <Project>{d53e8e48-cfaa-4f57-ac35-63bef4476159}</Project>
+      <Name>HeuristicLab.Problems.MultiObjectiveTestFunctions-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Choose>
+    <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
+      <ItemGroup>
+        <Reference Include="Microsoft.VisualStudio.QualityTools.CodedUITestFramework, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+          <Private>False</Private>
+        </Reference>
+        <Reference Include="Microsoft.VisualStudio.TestTools.UITest.Common, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+          <Private>False</Private>
+        </Reference>
+        <Reference Include="Microsoft.VisualStudio.TestTools.UITest.Extension, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+          <Private>False</Private>
+        </Reference>
+        <Reference Include="Microsoft.VisualStudio.TestTools.UITesting, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+          <Private>False</Private>
+        </Reference>
+      </ItemGroup>
+    </When>
+  </Choose>
+  <Import Project="$(VSToolsPath)\TeamTest\Microsoft.TestTools.targets" Condition="Exists('$(VSToolsPath)\TeamTest\Microsoft.TestTools.targets')" />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/Properties/AssemblyInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/Properties/AssemblyInfo.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/Properties/AssemblyInfo.cs	(revision 13673)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("MultiObjectiveTestfunctionTests")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("MultiObjectiveTestfunctionTests")]
+[assembly: AssemblyCopyright("Copyright ©  2015")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("2e42c743-37b3-494f-b30d-edb0069d73c1")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/SpacingTest.cs
===================================================================
--- branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/SpacingTest.cs	(revision 13673)
+++ branches/HeuristicLab.Problems.MultiObjectiveTestFunctions/MultiObjectiveTestfunctionTests/SpacingTest.cs	(revision 13673)
@@ -0,0 +1,134 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using HeuristicLab.Problems.MultiObjectiveTestFunctions;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace MultiObjectiveTestfunctionTests {
+  [TestClass]
+  public class SpacingTest {
+
+
+
+
+    [TestMethod]
+    [ExpectedException(typeof(ArgumentException))]
+    public void EmptyFrontTest() {
+      double[][] front = { };
+
+      Spacing.Calculate(front);
+    }
+
+    [TestMethod]
+    public void SamePointTest() {
+
+      double[] point = new double[2];
+      point[0] = 0.5;
+      point[1] = 0.5;
+
+      double[] point1 = new double[2];
+      point1[0] = 0.5;
+      point1[1] = 0.5;
+      double[][] front = { point, point1 };
+      double dist = Spacing.Calculate(front);
+      Assert.AreEqual(0, dist);
+    }
+
+    [TestMethod]
+    public void SinglePointTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[][] front = { point };
+      double dist = Spacing.Calculate(front);
+      Assert.AreEqual(0, dist);
+    }
+
+    [TestMethod]
+    public void QuadraticTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 1;
+      point3[1] = 1;
+      double[][] front = { point, point1, point2, point3 };
+      double dist = Spacing.Calculate(front);
+      Assert.AreEqual(0, dist);
+    }
+
+    [TestMethod]
+    public void RectangularTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+
+      double[] point2 = new double[2];
+      point2[0] = 2;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 2;
+      point3[1] = 1;
+      double[][] front = { point, point1, point2, point3 };
+      double dist = Spacing.Calculate(front);
+      Assert.AreEqual(0, dist);
+    }
+
+    /// <summary> 
+    /// deltoid with 3 points of the 1-unit-square and the northeastern point at 4,4
+    /// which gives d=(1,1,1,5) for minimal distances. Mean of d is 2 and variance of d is 3
+    /// Spacing is defined as the standarddeviation of d
+    /// </summary>
+    [TestMethod]
+    public void DeltoidTest() {
+      double[] point = new double[2];
+      point[0] = 0;
+      point[1] = 0;
+      double[] point1 = new double[2];
+      point1[0] = 0;
+      point1[1] = 1;
+
+      double[] point2 = new double[2];
+      point2[0] = 1;
+      point2[1] = 0;
+      double[] point3 = new double[2];
+      point3[0] = 4;
+      point3[1] = 4;
+      double[][] front = { point, point1, point2, point3 };
+      double dist = Spacing.Calculate(front);
+      Assert.AreEqual(Math.Sqrt(3), dist);
+    }
+
+
+  }
+
+
+}
